//main.c
short check_catalog_exists();

//proc.c
void *client( void *data );
int client_auth_proc( struct thread_t *self );
int client_open_db( struct thread_t *self );
int client_process( struct thread_t *self, char *query );
void client_session_init( struct thread_t *self );
void client_safe_exit( struct thread_t *self );

//request.c
int request_header_parse( struct request_t *request );
int request_end( struct request_t *request );
short request_keep_alive( struct request_t *request );
int request_get_char( char **dst, struct request_t *request, char *field );
int request_get_int( struct request_t *request, char *field );
int base64_decode( char *dst, const char *src, unsigned int len );
int request_decode( char *to, char *from, int from_len );
int request_decode_hexit( char c );

//admin.c
int admin_process( struct thread_t *self );
int admin_create_user( struct db_user_t *user_data );
int admin_drop_user( struct db_user_t *user_data );
int admin_user_manage( struct db_user_t *user_data, int method );

//libnetwork.c
int server_sock_init( sock_t *server_addr, short port, int backlog );
int net_send( int sock, char *buf, int len );
int net_sendfile( int sock, int filefd, off_t offset, ssize_t size );

//libsqlite3.c
int db_open( struct db_t *db, char *filename );
int db_close( struct db_t *db );
int db_open_init( struct db_t *db, char *filename, char *init_sql );
int db_throw( struct db_t *db, char *sql );
int db_commit( struct db_t *db );
int db_rollback( struct db_t *db );
int db_changes( struct db_t *db );
long long int db_last_rowid( struct db_t *db );
int db_table_columns( struct db_t *db );
int db_table_column_name( char **column_name, struct db_t *db, int offset );
int db_get_table( struct db_t *db, char *sql );
int db_table_num_rows( struct db_t *db );
int db_table_has_rows( struct db_t *db );
char *db_table_result( struct db_t *db, int row, int col );
void db_free_table( struct db_t *db );
char *db_printf( const char *sql, ...);
void db_free( char *sql );

//response.c
int response( struct thread_t *self );
int response_error( struct thread_t *self, int status, char *errmsg );
int response_info( struct thread_t *self, int status, char *infomsg );
int response_xml_printf( char *dst, const char *src, const int src_len );

//http.c
int http_proc( struct thread_t *self );
time_t http_asctime2time_t( char *asctime );
int http_ascmon2int( char *ascmonth );
int http_time2asctime( char *dst, time_t time );

//config.c
void init_config();
int parse_config( int argc, char **argv );
char *get_config_char( struct config_node_t *set, int set_len, char *find, char *def );
int get_config_int( struct config_node_t *set, int set_len, char *find, int def );
short get_config_bool( struct config_node_t *set, int set_len, char *find, short def );

//monitor.c
void monitor_thread_push( struct thread_t *self );
void monitor_thread_delete( struct thread_t *self );
int monitor_response( struct thread_t *self );
